
// method.cpp, build
// g++ -o im_test method.cpp -lbe /boot/system/servers/input_server


#include <Application.h>
#include <Alert.h>
#include <Menu.h>
#include <MenuItem.h>
#include <Messenger.h>
#include <SupportDefs.h>

#include <add-ons/input_server/InputServerMethod.h>

// circle icon
const uchar kCircle[] = {
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,
0xff,0xff,0x00,0x00,0x00,0x0d,0x1a,0x1f,0x1f,0x1a,0x0d,0x00,0x00,0x00,0xff,0xff,
0xff,0x00,0x00,0x00,0x0d,0x1e,0x1f,0x1f,0x1f,0x1f,0x1e,0x0d,0x00,0x00,0x00,0xff,
0xff,0x00,0x00,0x00,0x1a,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1a,0x00,0x00,0x00,0xff,
0xff,0x00,0x00,0x00,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x00,0x00,0x00,0xff,
0xff,0x00,0x00,0x00,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x00,0x00,0x00,0xff,
0xff,0x00,0x00,0x00,0x1a,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1a,0x00,0x00,0x00,0xff,
0xff,0x00,0x00,0x00,0x0d,0x1e,0x1f,0x1f,0x1f,0x1f,0x1e,0x0d,0x00,0x00,0x00,0xff,
0xff,0xff,0x00,0x00,0x00,0x0d,0x1a,0x1f,0x1f,0x1a,0x0d,0x00,0x00,0x00,0xff,0xff,
0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
};

// square icon
const uchar kSquare[] = {
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0xff,0x00,0x00,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x00,0x00,0xff,0xff,
0xff,0xff,0x00,0x00,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x00,0x00,0xff,0xff,
0xff,0xff,0x00,0x00,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x00,0x00,0xff,0xff,
0xff,0xff,0x00,0x00,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x00,0x00,0xff,0xff,
0xff,0xff,0x00,0x00,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x00,0x00,0xff,0xff,
0xff,0xff,0x00,0x00,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x00,0x00,0xff,0xff,
0xff,0xff,0x00,0x00,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x00,0x00,0xff,0xff,
0xff,0xff,0x00,0x00,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x00,0x00,0xff,0xff,
0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
};


class TestMethod : public BInputServerMethod
{
public:
             TestMethod();
    virtual ~TestMethod();

    virtual status_t      InitCheck();
    virtual filter_result Filter(BMessage* msg, BList* _list);
    virtual status_t      MethodActivated(bool active);

    void UpdateMenu();
private:
    BMessenger fLooper;
    BMenu* fDeskbarMenu;
};


extern "C" _EXPORT
BInputServerMethod *instantiate_input_method()
{
    return new TestMethod();
}


enum {
    IM_ALERT1 = 'Ima1',
    IM_ALERT2 = 'Ima2',
    IM_SQUARE = 'Imsq',
    IM_CIRCLE = 'Imci',
    IM_METHOD_ACTIVATED = 'Imac',
    IM_METHOD_DEACTIVATED = 'Imda',
};


class TestLooper : public BLooper
{
public:
    TestLooper(TestMethod* method);
    virtual ~TestLooper();

    virtual void MessageReceived(BMessage* msg);
private:
    TestMethod* fMethod;
};

TestLooper::TestLooper(TestMethod* method)
    : BLooper("test_looper")
    , fMethod(method)
{
    if (be_app) {
        if (be_app->Lock()) {
            be_app->AddHandler(this);
            be_app->Unlock();
        }
    }

    Run();
}

TestLooper::~TestLooper()
{
}

void TestLooper::MessageReceived(BMessage* msg)
{
    switch(msg->what)
    {
        case IM_ALERT1:
        {
            BAlert* alert = new BAlert("title1", "Alert 1", "OK");
            alert->Go();
            // without updating the menu, any menuitem would not trigger any event
            break;
        }
        case IM_ALERT2:
        {
            BAlert* alert = new BAlert("title2", "Alert 2 with set menu again", "OK");
            alert->Go();
            fMethod->UpdateMenu();
            break;
        }
        case IM_SQUARE:
        {
            fMethod->SetIcon(kSquare);
            fMethod->UpdateMenu();
            break;
        }
        case IM_CIRCLE:
        {
            fMethod->SetIcon(kCircle);
            fMethod->UpdateMenu();
            break;
        }
        case IM_METHOD_ACTIVATED:
        {
            // try to set menu again when this IM is activated
            fMethod->UpdateMenu();
            break;
        }
        case IM_METHOD_DEACTIVATED:
        {
            
            break;
        }
        default:
            break;
    }
}


TestMethod::TestMethod()
    : BInputServerMethod("im_test", kCircle)
{
    fDeskbarMenu = new BMenu("im_test");
    fDeskbarMenu->AddItem(new BMenuItem("Alert 1", new BMessage(IM_ALERT1)));
    fDeskbarMenu->AddItem(new BMenuItem("Alert 2", new BMessage(IM_ALERT2)));
    fDeskbarMenu->AddSeparatorItem();
    fDeskbarMenu->AddItem(new BMenuItem("Square", new BMessage(IM_SQUARE)));
    fDeskbarMenu->AddItem(new BMenuItem("Circle", new BMessage(IM_CIRCLE)));
}

TestMethod::~TestMethod()
{
    SetMenu(NULL, BMessenger());
    BLooper* looper = NULL;
    fLooper.Target(&looper);
    if (looper != NULL) {
        if (looper->Lock()) {
            looper->Quit();
        }
        delete looper;
        looper = NULL;
    }
}

void TestMethod::UpdateMenu()
{
    SetMenu(fDeskbarMenu, fLooper);
}

status_t TestMethod::InitCheck()
{
    TestLooper* looper = new TestLooper(this);
    fLooper = BMessenger(NULL, looper);
    UpdateMenu();
    return B_OK;
}

filter_result TestMethod::Filter(BMessage* msg, BList* _list)
{
    if (msg->what == B_KEY_DOWN) {
        fLooper.SendMessage(msg);
        return B_SKIP_MESSAGE;
    }
    return B_DISPATCH_MESSAGE;
}

status_t TestMethod::MethodActivated(bool active)
{
    BMessage msg(active ? IM_METHOD_ACTIVATED : IM_METHOD_DEACTIVATED);
    fLooper.SendMessage(&msg);
    return BInputServerMethod::MethodActivated(active);
}
